"use strict";
function _serializeArray(jsonObject, keys, path) {
    if (jsonObject.length) {
        for (var keyName in jsonObject) {
            if (keyName) {
                var keyValue = jsonObject[keyName];
                var elementName = path + "[" + keyName + "]";
                serializeToArray(keyValue, keys, elementName);
            }
        }
    }
    else {
        keys[path] = jsonObject;
    }
}
function _serializeObject(jsonObject, keys, path) {
    for (var keyName in jsonObject) {
        if (keyName) {
            var keyValue = jsonObject[keyName];
            var elementName = "" + keyName;
            if (path && typeof path === "string") {
                elementName = path + "." + keyName;
            }
            serializeToArray(keyValue, keys, elementName);
        }
    }
}
function serializeToArray(jsonObject, keys, path) {
    keys = keys || [];
    path = path || "";
    if (jsonObject instanceof Array) {
        _serializeArray(jsonObject, keys, path);
    }
    else if (jsonObject instanceof Object) {
        _serializeObject(jsonObject, keys, path);
    }
    else {
        keys[path] = jsonObject;
    }
    return keys;
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = serializeToArray;
