"use strict";
function _isArray(arr) {
    var keys = Object.keys(arr);
    var firstKey = keys[0];
    if (firstKey) {
        var isArrayRegexp = /^\[([0-9]+)\]/;
        return isArrayRegexp.test(firstKey);
    }
    return false;
}
function _serialize(jsonObject, key, value, path, index) {
    var currentKey = path[index];
    var isArray = /\[([0-9]+)\]$/;
    if (isArray.test(currentKey)) {
        return _serializeArray(jsonObject, index, currentKey, value, path, isArray);
    }
    else {
        return _serializeObject(jsonObject, index, currentKey, value, path);
    }
}
function _serializeObject(jsonObject, index, key, value, path) {
    if (typeof jsonObject === "object") {
        if (!(key in jsonObject)) {
            jsonObject[key] = jsonObject[key] || {};
        }
        var pathLength = path.length - 1;
        if (index === pathLength) {
            jsonObject[key] = value;
        }
        else {
            jsonObject[key] = jsonObject[key] || {};
            jsonObject = jsonObject[key];
        }
    }
    return jsonObject;
}
function _serializeArray(jsonObject, index, key, value, path, isArray) {
    var arrayIndex = key.match(isArray)[1];
    var formattedCurrentKey = key.replace(isArray, "");
    var indexNextItem = index + 1;
    if (formattedCurrentKey) {
        jsonObject[formattedCurrentKey] = jsonObject[formattedCurrentKey] || [];
        if (indexNextItem < path.length) {
            jsonObject[formattedCurrentKey][arrayIndex] = jsonObject[formattedCurrentKey][arrayIndex] || {};
            jsonObject = jsonObject[formattedCurrentKey][arrayIndex];
        }
        else {
            jsonObject[formattedCurrentKey][arrayIndex] = value;
        }
    }
    else {
        if (indexNextItem < path.length) {
            jsonObject[arrayIndex] = jsonObject[arrayIndex] || {};
            jsonObject = jsonObject[arrayIndex];
        }
        else {
            jsonObject[arrayIndex] = value;
        }
    }
    return jsonObject;
}
function serializeToObject(arr) {
    var jsonObject = {};
    if (_isArray(arr)) {
        jsonObject = [];
    }
    for (var key in arr) {
        if (key) {
            var value = arr[key];
            var path = key.split(".");
            var currentJsonObject = jsonObject;
            for (var index = 0; index < path.length; index++) {
                currentJsonObject = _serialize(currentJsonObject, key, value, path, index);
            }
        }
    }
    return jsonObject;
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = serializeToObject;
